import junit.framework.*;

public class SpareFrameTest extends TestCase
{
    private Frame spareFrame;

    protected void setUp()
    {
        spareFrame = new Frame();
        spareFrame.roll( 4 );
        spareFrame.roll( 6 );
        spareFrame.roll( 5 );
        spareFrame.roll( 0 );
    }

    public void testSingleSpare()
    {
        assertEquals( 15, spareFrame.score() );
    }

    public void testSingleSpareAll()
    {
        assertEquals( 20, spareFrame.gameScore() );
    }

    public void testSeveralSpares()
    {
        for ( int i = 0; i < 4; i++ )
        {
            spareFrame.roll( 1 );
            spareFrame.roll( 9 );
            spareFrame.roll( 2 );
            spareFrame.roll( 6 );
        }
        assertEquals( 100, spareFrame.gameScore() );
    }

    public void testSpareInLastFrame()    // tries to score "eleventh frame"
    {
        Frame spareFrame = new Frame();
        for ( int i = 0; i < 18; i++ )
            spareFrame.roll( 0 );

        spareFrame.roll( 5 );
        spareFrame.roll( 5 );
        spareFrame.roll( 5 );
        assertEquals( 15, spareFrame.gameScore() );
    }

    public static Test suite()
    {
        return new TestSuite( SpareFrameTest.class );
    }

    public static void main( String[] args )
    {
        junit.textui.TestRunner.run( suite() );
    }
}
